//+------------------------------------------------------------------+
//|                                              CCheckNewCandle.mqh |
//|                           Copyright 2016, Artem Virsky (virart). |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Artem Virsky (virart)"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Class CCheckNewCandle                                            |
//+------------------------------------------------------------------+
class CCheckNewCandle
  {
private:
  struct data
  {
    ENUM_TIMEFRAMES tf;
    bool nw;
    datetime last;
  };
  data per[10];
public:
  string  sSymbol;
  void    CheckNew(); 
  bool    NW();       
  void    CheckNew(ENUM_TIMEFRAMES timeframe); 
  bool    NW(ENUM_TIMEFRAMES timeframe); 
    CCheckNewCandle();              //Constructor default      
    CCheckNewCandle(string symbol); //Constructor with parametr
  };
//+------------------------------------------------------------------+
//| Constructor with parametr                                        |
//+------------------------------------------------------------------+
CCheckNewCandle::CCheckNewCandle(string symbol)
  {
  per[0].tf=PERIOD_CURRENT;
  per[1].tf=PERIOD_M1;
  per[2].tf=PERIOD_M5;
  per[3].tf=PERIOD_M15;
  per[4].tf=PERIOD_M30;
  per[5].tf=PERIOD_H1;
  per[6].tf=PERIOD_H4;
  per[7].tf=PERIOD_D1;
  per[8].tf=PERIOD_W1;
  per[9].tf=PERIOD_MN1;
  
  sSymbol=symbol;
  for(int i=0; i!=10; i++)
    {
    per[i].nw=false;
    per[i].last=iTime(sSymbol,per[i].tf,0);
    }
  }
//+------------------------------------------------------------------+
//| Constructor default                                              |
//+------------------------------------------------------------------+
CCheckNewCandle::CCheckNewCandle()
  {
  per[0].tf=PERIOD_CURRENT;
  per[1].tf=PERIOD_M1;
  per[2].tf=PERIOD_M5;
  per[3].tf=PERIOD_M15;
  per[4].tf=PERIOD_M30;
  per[5].tf=PERIOD_H1;
  per[6].tf=PERIOD_H4;
  per[7].tf=PERIOD_D1;
  per[8].tf=PERIOD_W1;
  per[9].tf=PERIOD_MN1;
  
  sSymbol=_Symbol;
  for(int i=0; i!=10; i++)
    {
    per[i].nw=false;
    per[i].last=iTime(sSymbol,per[i].tf,0);
    }
  }
//+------------------------------------------------------------------+
//| Without parametr - check the new candles in all TF               |
//+------------------------------------------------------------------+
void CCheckNewCandle::CheckNew()
  {
    for(int i=0; i!=10; i++) {CheckNew(per[i].tf);}    
  }
//+------------------------------------------------------------------+
//| Returns whether a new candle on the current TF after the last    |
//| check                                                            |
//+------------------------------------------------------------------+
bool CCheckNewCandle::NW()
  {
    return(per[0].nw);
  }
//+------------------------------------------------------------------+
//| Returns whether a new candle on a given TF since the last check  |
//+------------------------------------------------------------------+
bool CCheckNewCandle::NW(ENUM_TIMEFRAMES timeframe)
  {
    for(int i=0; i!=10; i++)
     {
     if(per[i].tf==timeframe) return(per[i].nw);
     }
    Print("Uncorrect TF! ",timeframe," ",__FUNCTION__);
    return(false);
  }
//+------------------------------------------------------------------+
//| Check the new candles in given TF                                |
//+------------------------------------------------------------------+
void CCheckNewCandle::CheckNew(ENUM_TIMEFRAMES timeframe)
  {
    for(int i=0; i!=10; i++)
    {
      if(per[i].tf==timeframe)
      {
        per[i].nw=false;
        if(per[i].last!=iTime(sSymbol,per[i].tf,0))
          {
          per[i].nw=true;
          per[i].last=iTime(sSymbol,per[i].tf,0);      
          }
        return;
      }
    }
    Print("Uncorrect TF! ",timeframe," ", __FUNCTION__);
  }

